/// <reference types="react" />
import * as React from 'react';
import { ReactElement } from 'react';
export interface Mapper<T> {
    <U>(value: T): U;
    <U>(value: T, key: number): U;
    <U>(value: T, key: number, target: T[]): U;
}
/**
 * Conditionally render components based on the truthy-ness of evaluating the `test` prop.
 * Render `then` if `test` evaluates to truthy, render `else` otherwise.
 */
export declare function If({test, then, 'else': _else}: {
    test: any;
    then: any;
    else?: any;
}): any;
export declare function Switch({children}: {
    children: any;
}): any;
export declare function When(_: {
    test: any;
    render: () => any;
}): any;
/**
 * Render the result of dispatching to the `map` method of `target`
 * passing the `with` function as the first argument.
 */
export declare function Map<T>({target, 'with': _with}: {
    target: T[];
    with: Mapper<T>;
}): ReactElement<any>;
/**
 * A component that its `constructor`, `shouldComponentUpdate`, and lifecycle methods
 * can be assigned via props
 */
export declare class Bare extends React.Component<{
    render: any;
    constructor?: Function;
    pureBy?: any;
    didCatch?: (...args: any[]) => any;
    didMount?: (...args: any[]) => any;
    didUpdate?: (...args: any[]) => any;
    shouldUpdate?: (...args: any[]) => any;
    willUnmount?: (...args: any[]) => any;
}> {
    previousPuritySource: any;
    constructor(props: any, ctx: any);
    render(): any;
}
